# Records API: Gradebooks

## GET /api/records/gradebooks/{gradebook}

> Retrieves one specific gradebook

```json
{"openapi":"3.0.1","info":{"title":"Developer API","version":"v2.0.0"},"servers":[{"url":"/v2/e01"}],"security":[{"Bearer":[]},{"Cookie":[]}],"components":{"securitySchemes":{"Bearer":{"type":"apiKey","description":"-","name":"Bearer","in":"header"},"Cookie":{"type":"apiKey","description":"-","name":"InSite.WebToken","in":"cookie"}},"schemas":{"ProblemDetails":{"type":"object","properties":{"Type":{"type":"string","nullable":true},"Title":{"type":"string","nullable":true},"Status":{"type":"integer","format":"int32","nullable":true},"Detail":{"type":"string","nullable":true},"Instance":{"type":"string","nullable":true}},"additionalProperties":{}}}},"paths":{"/api/records/gradebooks/{gradebook}":{"get":{"tags":["Records API: Gradebooks"],"summary":"Retrieves one specific gradebook","operationId":"retrieveGradebook","parameters":[{"name":"gradebook","in":"path","required":true,"schema":{"type":"string","format":"uuid"}}],"responses":{"404":{"description":"Not Found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}},"text/json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}}}
```

## HEAD /api/records/gradebooks/{gradebook}

> Checks for the existence of one specific gradebook

```json
{"openapi":"3.0.1","info":{"title":"Developer API","version":"v2.0.0"},"servers":[{"url":"/v2/e01"}],"security":[{"Bearer":[]},{"Cookie":[]}],"components":{"securitySchemes":{"Bearer":{"type":"apiKey","description":"-","name":"Bearer","in":"header"},"Cookie":{"type":"apiKey","description":"-","name":"InSite.WebToken","in":"cookie"}},"schemas":{"ProblemDetails":{"type":"object","properties":{"Type":{"type":"string","nullable":true},"Title":{"type":"string","nullable":true},"Status":{"type":"integer","format":"int32","nullable":true},"Detail":{"type":"string","nullable":true},"Instance":{"type":"string","nullable":true}},"additionalProperties":{}}}},"paths":{"/api/records/gradebooks/{gradebook}":{"head":{"tags":["Records API: Gradebooks"],"summary":"Checks for the existence of one specific gradebook","operationId":"assertGradebook","parameters":[{"name":"gradebook","in":"path","required":true,"schema":{"type":"string","format":"uuid"}}],"responses":{"200":{"description":"OK"},"404":{"description":"Not Found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}},"text/json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}}}
```

## POST /api/records/gradebooks/collect

> Collects the list of gradebooks that match specific criteria

```json
{"openapi":"3.0.1","info":{"title":"Developer API","version":"v2.0.0"},"servers":[{"url":"/v2/e01"}],"security":[{"Bearer":[]},{"Cookie":[]}],"components":{"securitySchemes":{"Bearer":{"type":"apiKey","description":"-","name":"Bearer","in":"header"},"Cookie":{"type":"apiKey","description":"-","name":"InSite.WebToken","in":"cookie"}},"schemas":{"CollectGradebooks":{"type":"object","properties":{"AchievementId":{"type":"string","format":"uuid","nullable":true},"ClassId":{"type":"string","format":"uuid","nullable":true},"ClassInstructorId":{"type":"string","format":"uuid","nullable":true},"FrameworkId":{"type":"string","format":"uuid","nullable":true},"PeriodId":{"type":"string","format":"uuid","nullable":true},"IsLocked":{"type":"boolean","nullable":true},"ClassTitle":{"type":"string","nullable":true},"GradebookTitle":{"type":"string","nullable":true},"GradebookType":{"type":"string","nullable":true},"LastChangeType":{"type":"string","nullable":true},"LastChangeUser":{"type":"string","nullable":true},"Reference":{"type":"string","nullable":true},"ClassStartedSince":{"type":"string","format":"date-time","nullable":true},"ClassStartedBefore":{"type":"string","format":"date-time","nullable":true},"GradebookCreatedSince":{"type":"string","format":"date-time","nullable":true},"GradebookCreatedBefore":{"type":"string","format":"date-time","nullable":true},"LastChangeSince":{"type":"string","format":"date-time","nullable":true},"LastChangeBefore":{"type":"string","format":"date-time","nullable":true}},"additionalProperties":false},"GradebookModel":{"type":"object","properties":{"AchievementId":{"type":"string","format":"uuid","nullable":true},"EventId":{"type":"string","format":"uuid","nullable":true},"FrameworkId":{"type":"string","format":"uuid","nullable":true},"GradebookId":{"type":"string","format":"uuid"},"PeriodId":{"type":"string","format":"uuid","nullable":true},"IsLocked":{"type":"boolean"},"GradebookTitle":{"type":"string","nullable":true},"GradebookType":{"type":"string","nullable":true},"LastChangeType":{"type":"string","nullable":true},"LastChangeUser":{"type":"string","nullable":true},"Reference":{"type":"string","nullable":true},"GradebookCreated":{"type":"string","format":"date-time"},"LastChangeTime":{"type":"string","format":"date-time"},"AchievementTitle":{"type":"string","nullable":true},"ClassInstructors":{"type":"string","nullable":true},"ClassScheduledStartDate":{"type":"string","nullable":true},"ClassScheduledEndDate":{"type":"string","nullable":true},"ClassTitle":{"type":"string","nullable":true}},"additionalProperties":false}}},"paths":{"/api/records/gradebooks/collect":{"post":{"tags":["Records API: Gradebooks"],"summary":"Collects the list of gradebooks that match specific criteria","operationId":"collectGradebooks","requestBody":{"content":{"application/json-patch+json":{"schema":{"$ref":"#/components/schemas/CollectGradebooks"}},"application/json":{"schema":{"$ref":"#/components/schemas/CollectGradebooks"}},"text/json":{"schema":{"$ref":"#/components/schemas/CollectGradebooks"}},"application/*+json":{"schema":{"$ref":"#/components/schemas/CollectGradebooks"}}}},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GradebookModel"}}},"text/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GradebookModel"}}}}}}}}}}
```

## POST /api/records/gradebooks/count

> Counts the gradebooks that match specific criteria

```json
{"openapi":"3.0.1","info":{"title":"Developer API","version":"v2.0.0"},"servers":[{"url":"/v2/e01"}],"security":[{"Bearer":[]},{"Cookie":[]}],"components":{"securitySchemes":{"Bearer":{"type":"apiKey","description":"-","name":"Bearer","in":"header"},"Cookie":{"type":"apiKey","description":"-","name":"InSite.WebToken","in":"cookie"}},"schemas":{"CountGradebooks":{"type":"object","properties":{"AchievementId":{"type":"string","format":"uuid","nullable":true},"ClassId":{"type":"string","format":"uuid","nullable":true},"ClassInstructorId":{"type":"string","format":"uuid","nullable":true},"FrameworkId":{"type":"string","format":"uuid","nullable":true},"PeriodId":{"type":"string","format":"uuid","nullable":true},"IsLocked":{"type":"boolean","nullable":true},"ClassTitle":{"type":"string","nullable":true},"GradebookTitle":{"type":"string","nullable":true},"GradebookType":{"type":"string","nullable":true},"LastChangeType":{"type":"string","nullable":true},"LastChangeUser":{"type":"string","nullable":true},"Reference":{"type":"string","nullable":true},"ClassStartedSince":{"type":"string","format":"date-time","nullable":true},"ClassStartedBefore":{"type":"string","format":"date-time","nullable":true},"GradebookCreatedSince":{"type":"string","format":"date-time","nullable":true},"GradebookCreatedBefore":{"type":"string","format":"date-time","nullable":true},"LastChangeSince":{"type":"string","format":"date-time","nullable":true},"LastChangeBefore":{"type":"string","format":"date-time","nullable":true}},"additionalProperties":false},"CountResult":{"type":"object","properties":{"Count":{"type":"integer","format":"int32"},"Summary":{"type":"string","nullable":true}},"additionalProperties":false}}},"paths":{"/api/records/gradebooks/count":{"post":{"tags":["Records API: Gradebooks"],"summary":"Counts the gradebooks that match specific criteria","operationId":"countGradebooks","requestBody":{"content":{"application/json-patch+json":{"schema":{"$ref":"#/components/schemas/CountGradebooks"}},"application/json":{"schema":{"$ref":"#/components/schemas/CountGradebooks"}},"text/json":{"schema":{"$ref":"#/components/schemas/CountGradebooks"}},"application/*+json":{"schema":{"$ref":"#/components/schemas/CountGradebooks"}}}},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CountResult"}},"text/json":{"schema":{"$ref":"#/components/schemas/CountResult"}}}}}}}}}
```

## POST /api/records/gradebooks/download

> Downloads the list of gradebooks that match specific criteria

```json
{"openapi":"3.0.1","info":{"title":"Developer API","version":"v2.0.0"},"servers":[{"url":"/v2/e01"}],"security":[{"Bearer":[]},{"Cookie":[]}],"components":{"securitySchemes":{"Bearer":{"type":"apiKey","description":"-","name":"Bearer","in":"header"},"Cookie":{"type":"apiKey","description":"-","name":"InSite.WebToken","in":"cookie"}},"schemas":{"CollectGradebooks":{"type":"object","properties":{"AchievementId":{"type":"string","format":"uuid","nullable":true},"ClassId":{"type":"string","format":"uuid","nullable":true},"ClassInstructorId":{"type":"string","format":"uuid","nullable":true},"FrameworkId":{"type":"string","format":"uuid","nullable":true},"PeriodId":{"type":"string","format":"uuid","nullable":true},"IsLocked":{"type":"boolean","nullable":true},"ClassTitle":{"type":"string","nullable":true},"GradebookTitle":{"type":"string","nullable":true},"GradebookType":{"type":"string","nullable":true},"LastChangeType":{"type":"string","nullable":true},"LastChangeUser":{"type":"string","nullable":true},"Reference":{"type":"string","nullable":true},"ClassStartedSince":{"type":"string","format":"date-time","nullable":true},"ClassStartedBefore":{"type":"string","format":"date-time","nullable":true},"GradebookCreatedSince":{"type":"string","format":"date-time","nullable":true},"GradebookCreatedBefore":{"type":"string","format":"date-time","nullable":true},"LastChangeSince":{"type":"string","format":"date-time","nullable":true},"LastChangeBefore":{"type":"string","format":"date-time","nullable":true}},"additionalProperties":false}}},"paths":{"/api/records/gradebooks/download":{"post":{"tags":["Records API: Gradebooks"],"summary":"Downloads the list of gradebooks that match specific criteria","operationId":"downloadGradebooks","requestBody":{"content":{"application/json-patch+json":{"schema":{"$ref":"#/components/schemas/CollectGradebooks"}},"application/json":{"schema":{"$ref":"#/components/schemas/CollectGradebooks"}},"text/json":{"schema":{"$ref":"#/components/schemas/CollectGradebooks"}},"application/*+json":{"schema":{"$ref":"#/components/schemas/CollectGradebooks"}}}},"responses":{"200":{"description":"OK"}}}}}}
```

## POST /api/records/gradebooks/search

> Searches for the list of gradebooks that match specific criteria

```json
{"openapi":"3.0.1","info":{"title":"Developer API","version":"v2.0.0"},"servers":[{"url":"/v2/e01"}],"security":[{"Bearer":[]},{"Cookie":[]}],"components":{"securitySchemes":{"Bearer":{"type":"apiKey","description":"-","name":"Bearer","in":"header"},"Cookie":{"type":"apiKey","description":"-","name":"InSite.WebToken","in":"cookie"}},"schemas":{"SearchGradebooks":{"type":"object","properties":{"AchievementId":{"type":"string","format":"uuid","nullable":true},"ClassId":{"type":"string","format":"uuid","nullable":true},"ClassInstructorId":{"type":"string","format":"uuid","nullable":true},"FrameworkId":{"type":"string","format":"uuid","nullable":true},"PeriodId":{"type":"string","format":"uuid","nullable":true},"IsLocked":{"type":"boolean","nullable":true},"ClassTitle":{"type":"string","nullable":true},"GradebookTitle":{"type":"string","nullable":true},"GradebookType":{"type":"string","nullable":true},"LastChangeType":{"type":"string","nullable":true},"LastChangeUser":{"type":"string","nullable":true},"Reference":{"type":"string","nullable":true},"ClassStartedSince":{"type":"string","format":"date-time","nullable":true},"ClassStartedBefore":{"type":"string","format":"date-time","nullable":true},"GradebookCreatedSince":{"type":"string","format":"date-time","nullable":true},"GradebookCreatedBefore":{"type":"string","format":"date-time","nullable":true},"LastChangeSince":{"type":"string","format":"date-time","nullable":true},"LastChangeBefore":{"type":"string","format":"date-time","nullable":true}},"additionalProperties":false},"GradebookMatch":{"type":"object","properties":{"GradebookId":{"type":"string","format":"uuid"},"GradebookTitle":{"type":"string","nullable":true},"GradebookCreated":{"type":"string","format":"date-time"},"GradebookEnrollmentCount":{"type":"integer","format":"int32"},"ClassId":{"type":"string","format":"uuid","nullable":true},"ClassTitle":{"type":"string","nullable":true},"ClassStarted":{"type":"string","format":"date-time","nullable":true},"ClassEnded":{"type":"string","format":"date-time","nullable":true},"AchievementId":{"type":"string","format":"uuid","nullable":true},"AchievementTitle":{"type":"string","nullable":true},"AchievementCountGranted":{"type":"integer","format":"int32"},"IsLocked":{"type":"boolean"}},"additionalProperties":false}}},"paths":{"/api/records/gradebooks/search":{"post":{"tags":["Records API: Gradebooks"],"summary":"Searches for the list of gradebooks that match specific criteria","operationId":"searchGradebooks","requestBody":{"content":{"application/json-patch+json":{"schema":{"$ref":"#/components/schemas/SearchGradebooks"}},"application/json":{"schema":{"$ref":"#/components/schemas/SearchGradebooks"}},"text/json":{"schema":{"$ref":"#/components/schemas/SearchGradebooks"}},"application/*+json":{"schema":{"$ref":"#/components/schemas/SearchGradebooks"}}}},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GradebookMatch"}}},"text/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GradebookMatch"}}}}}}}}}}
```

## GET /api/records/gradebooks/export

> DO NOT use allow this endpoint to be used in live Production environments. When time and budget permit, we will> \
> design and implement a fire-and-forget strategy managing a queue of large exports, reports, etc.

```json
{"openapi":"3.0.1","info":{"title":"Developer API","version":"v2.0.0"},"servers":[{"url":"/v2/e01"}],"security":[{"Bearer":[]},{"Cookie":[]}],"components":{"securitySchemes":{"Bearer":{"type":"apiKey","description":"-","name":"Bearer","in":"header"},"Cookie":{"type":"apiKey","description":"-","name":"InSite.WebToken","in":"cookie"}},"schemas":{"ExportStarted":{"type":"object","properties":{"DownloadUrl":{"type":"string","nullable":true},"ExportFormat":{"type":"string","nullable":true},"ExportKey":{"type":"string","nullable":true},"Expiry":{"type":"string","format":"date-time"}},"additionalProperties":false}}},"paths":{"/api/records/gradebooks/export":{"get":{"tags":["Records API: Gradebooks"],"description":"DO NOT use allow this endpoint to be used in live Production environments. When time and budget permit, we will\r\ndesign and implement a fire-and-forget strategy managing a queue of large exports, reports, etc.","parameters":[{"name":"AchievementId","in":"query","schema":{"type":"string","format":"uuid"}},{"name":"ClassId","in":"query","schema":{"type":"string","format":"uuid"}},{"name":"ClassInstructorId","in":"query","schema":{"type":"string","format":"uuid"}},{"name":"FrameworkId","in":"query","schema":{"type":"string","format":"uuid"}},{"name":"OrganizationId","in":"query","schema":{"type":"string","format":"uuid"}},{"name":"PeriodId","in":"query","schema":{"type":"string","format":"uuid"}},{"name":"IsLocked","in":"query","schema":{"type":"boolean"}},{"name":"ClassTitle","in":"query","schema":{"type":"string"}},{"name":"GradebookTitle","in":"query","schema":{"type":"string"}},{"name":"GradebookType","in":"query","schema":{"type":"string"}},{"name":"LastChangeType","in":"query","schema":{"type":"string"}},{"name":"LastChangeUser","in":"query","schema":{"type":"string"}},{"name":"Reference","in":"query","schema":{"type":"string"}},{"name":"ClassStartedSince","in":"query","schema":{"type":"string","format":"date-time"}},{"name":"ClassStartedBefore","in":"query","schema":{"type":"string","format":"date-time"}},{"name":"GradebookCreatedSince","in":"query","schema":{"type":"string","format":"date-time"}},{"name":"GradebookCreatedBefore","in":"query","schema":{"type":"string","format":"date-time"}},{"name":"LastChangeSince","in":"query","schema":{"type":"string","format":"date-time"}},{"name":"LastChangeBefore","in":"query","schema":{"type":"string","format":"date-time"}},{"name":"Identifier","in":"query","schema":{"type":"string","format":"uuid"}},{"name":"Origin.When","in":"query","schema":{"type":"string","format":"date-time"}},{"name":"Origin.Organization","in":"query","schema":{"type":"string","format":"uuid"}},{"name":"Origin.User","in":"query","schema":{"type":"string","format":"uuid"}},{"name":"Origin.Proxy","in":"query","schema":{"type":"string","format":"uuid"}},{"name":"Origin.Description","in":"query","schema":{"type":"string"}},{"name":"Origin.Reason","in":"query","schema":{"type":"string"}},{"name":"Origin.Source","in":"query","schema":{"type":"string"}},{"name":"Filter.Page","in":"query","schema":{"type":"integer","format":"int32"}},{"name":"Filter.PageSize","in":"query","schema":{"type":"integer","format":"int32"}},{"name":"Filter.Sort","in":"query","schema":{"type":"string"}},{"name":"Filter.Excludes","in":"query","schema":{"type":"string"}},{"name":"Filter.Includes","in":"query","schema":{"type":"string"}},{"name":"Filter.Format","in":"query","schema":{"type":"string"}},{"name":"Texts","in":"query","schema":{"type":"object","additionalProperties":{"type":"string","nullable":true}}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ExportStarted"}},"text/json":{"schema":{"$ref":"#/components/schemas/ExportStarted"}}}}}}}}}
```

## GET /api/records/gradebooks/exports/{key}

>

```json
{"openapi":"3.0.1","info":{"title":"Developer API","version":"v2.0.0"},"servers":[{"url":"/v2/e01"}],"security":[{"Bearer":[]},{"Cookie":[]}],"components":{"securitySchemes":{"Bearer":{"type":"apiKey","description":"-","name":"Bearer","in":"header"},"Cookie":{"type":"apiKey","description":"-","name":"InSite.WebToken","in":"cookie"}}},"paths":{"/api/records/gradebooks/exports/{key}":{"get":{"tags":["Records API: Gradebooks"],"parameters":[{"name":"key","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK"}}}}}}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.shiftiq.com/developers/api-v2/navigating-the-api/records-api-gradebooks.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
